CON
   _clkmode  = xtal1 + pll16x
   _xinfreq  = 5_000_000
  
VAR
  long  scale
  long  size

OBJ
  lcd : "Nokia6100"
  SID : "SIDCog"
  
PUB start | r,s,m,n,p,q,u,v,i, j, a, b, c, d, dx, dy, x, y, color, xz, yz, tm

  SID.start
  SID.setFilterType(false,false,false)
  SID.setFilterMask(false,false,false)
  SID.setWaveform(0,2)
  SID.setPWM(0,1928)
  SID.setADSR(0,2,5,9,6)
  SID.setWaveform(1,3)  
  SID.setADSR(1,0,8,4,7)
  SID.setWaveform(2,1)
  SID.setADSR(2,7,4,8,9)
  SID.setVolume(10)

  lcd.start(4, 5, 6, 7, lcd#EPSON)
  lcd.background(lcd#BLACK)  
  lcd.color(lcd#WHITE)
  lcd.clear

  tm:=0

  scale := 1<<12
  size  := 2
  
  a:=scale*(-55)+500
  b:=scale*(-1)  
  c:=scale*(-42)+500

  x:=scale*0
  y:=scale*0

  repeat
    d := d+1
    i := x
    j := y
    r := (b*x)/scale
    r := -x+42*scale
'   r := -x+(b*scale)
    r := r-c
    r := ||r
    m := r//scale
    r := ^^(r/scale)
    r := scale*r+m
    s := x<0
    x := j-(r*s)
    y := a-i

    color++

    if color >500
     color:=0
      lcd.clear

    xz:= 80+((x/size/scale)/2)
    yz:= 60+((y/size/scale))

    lcd.plot(77+(x/size/scale),80+(y/size/scale))

    tm++

    if tm>250
      tm:=0
      SID.noteOn(0,note2freq(xz))
      waitcnt(cnt + (xz/4)*clkfreq/yz)
      SID.noteOff(0)

PUB note2freq(note) | octave
    octave := note/12
    note -= octave*12 
    return (noteTable[note]>>(8-octave))

DAT
noteTable word 16350, 17320, 18350, 19450, 20600, 21830, 23120, 24500, 25960, 27500, 29140, 30870
                                           